//-----------------------------------------------------------
//
// SSE2030: Introduction to Computer Systems (Fall 2012)
//
// Skeleton code for PA#1
//
// September 3, 2012.
// CSLab, Sungkyunkwan University
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include "topk.h"

int getTopK(char* fileName, int numk, struct wordcount *topk);

int main(int argc, char** argv) {
	struct timeval start_t, end_t, result_t;
	struct wordcount *topk;
	unsigned int nWords;
	int numk;
	int i;

	if(argc!=3) {
		printf("Usage : %s [text file] [numK]\n", argv[0]);
		return 1;
	}
	
	numk = atoi(argv[2]);
	topk = (struct wordcount*)malloc(sizeof(struct wordcount)*numk);
	
	/*************************************
	 * Top-K Printer
	 *************************************/
	printf("** Top-%d words in [%s] : Start\t**\n", numk, argv[1]);
	gettimeofday(&start_t, NULL);

	// Calculate Top-10 words, return Top-10 words pointer array
	nWords = getTopK(argv[1], numk, topk);

	gettimeofday(&end_t, NULL);
	timersub(&end_t, &start_t, &result_t);
	
	// print top-k words
	printf("Total words : %u\n", nWords);
	printf("Top %d words\n", numk);
	for(i=0; i<numk; i++) {
			printf("%3d : %5u %s\n", i+1, topk[i].count, topk[i].word);
	}

	printf("** Elapsed Time  : %ld(usec)\n",
			1000000*(result_t.tv_sec)+result_t.tv_usec);
	
	return 0;
}
